/*  Copyright (c) MIPoPS. All Rights Reserved.
 *
 *  Use of this source code is governed by a Unlicense license that can
 *  be found in the LICENSE file in the root of the source tree.
 */

//---------------------------------------------------------------------------
#pragma once
#ifdef MEDIAINFO_DLL
    #include "MediaInfoDLL/MediaInfoDLL.h"
    #define MediaInfoNameSpace MediaInfoDLL
#elif defined MEDIAINFO_STATIC
    #include "MediaInfoDLL/MediaInfoDLL_Static.h"
    #define MediaInfoNameSpace MediaInfoDLL
#else
    #include "MediaInfo/MediaInfoList.h"
    #define MediaInfoNameSpace MediaInfoLib
#endif
#include "MediaInfo/MediaInfo_Events.h"
#include <vector>
using namespace MediaInfoNameSpace;
using namespace std;
//---------------------------------------------------------------------------

//***************************************************************************
// Class Core
//***************************************************************************

class Core
{
public:
    // Constructor/Destructor
    Core();
    ~Core();

    // Data
    vector<String>  Inputs;
    bool            Xml;

    // Process
    void            Process();
    float           State();

    // Handle content from MediaInfo
    void            Parse_NewFile();
    void            Parse_AddFrame(const MediaInfo_Event_DvDif_Analysis_Frame_0* FrameData);
    void            Parse_Clear();

    // Output
    string          OutputXml();

protected:
    // MediaInfo handler
    MediaInfoList* MI;

    // Internal
    std::vector<std::vector<MediaInfo_Event_DvDif_Analysis_Frame_0>*> ParsedFrames;
};
